Subject: Re: [ippm] AD review of draft-ietf-ippm-6man-pdm-option-03

From: <[email-masked]>
Date: Tue, 13 Sep 2016 23:04:50 +0000 (UTC)

Spencer,

We have (we believe!) addressed your comments as well as those from Al Morton as document shepherd.

The new version is at:

https://tools.ietf.org/html/draft-ietf-ippm-6man-pdm-option-04

We have added quite a bit to the Security Considerations.  We have started implementation of PDM in the FreeBSD kernel, as I might have mentioned before.   It has shed quite a bit of light on the potential hazards which may come up as far as DOS attacks, etc.   That was helpful to us in doing the Security Considerations.

Many thanks to both you and Al Morton for your help and comments.

- Nalini Elkins - on behalf of the PDM co-authors (Mike Ackermann and Rob Hamilton)
Inside Products, Inc.
www.insidethestack.com
(831) 659-8360

________________________________
From: Spencer Dawkins at IETF <[email-masked]>
To: [email-masked] 
Cc: [email-masked]
Sent: Monday, August 22, 2016 5:37 PM
Subject: AD review of draft-ietf-ippm-6man-pdm-option-03

Dear Authors,

Nice work, and this would have been very valuable when I was implementing performance monitors at Tektronix, so I imagine it's equally valuable now.

I do have some comments that I'd like you let you consider before I request IETF Last Call for this draft. Please let me know if you have any questions, of course.

Thanks,

Spencer

I saw the abstract following the table of contents mentioned in the shepherd write-up, but https://tools.ietf.org/html/rfc7322#section-4.7 says 

   A Table of Contents (TOC) is required in all RFCs.  It must be
   positioned after the Copyright Notice and before the Introduction.
   
It's probably a good thing to use the organization from RFC 7322, just to sidestep reviewers who start out complaining about document structure nits and then keep on typing. Not that I ever did that in six years as a Gen-ART reviwer, of course :-) ...

I probably lack imagination, but perhaps other readers will, also.

In this text

   DELTATLR = Send time packet 2 - Receive time packet 1
   
and

   Delta Time Last Sent = Receive time packet 2 - Send time packet 1
   
these are mathematical expressions, aren't they? If so, that would likely be clearer if the right side terms had parentheses around the expression.

(It's a bit odd that the first expression uses the abbreviation DELTATLR and the second term is spelled out as "Delta Time Last Sent" - you might think about which seems clearer, and do that with both expressions)

In text like this

   We propose a base unit for the time.  
   
you probably want to use a verb like "specify" (when the draft is published as an RFC, it will no longer be a proposal). There are multiple occurrences of "propose" in the document, so this comment applies in multiple places.

For this text

   Assume that two packets are sent for each ACK from the server.
   
you might point out that TCP does this, per RFC 1122 Section 4.2.3.2. 

In this text from 6.3 PDM Flow - Multiple Send with Errors

   One might wonder if all of the functions of PDM might be better
   suited to TCP or a TCP option.
   
that's an interesting point in the broader sense, because (duh) putting PDM in a TCP option doesn't help you with any other transport protocol (SCTP, QUIC, what else are we doing these days? and, of course, they're all running over UDP anyway). I wonder if that's worth pointing out earlier in the document, perhaps in Section 1.4? 

This text

   Let's say that packet 4 STILL does not make it.
   
is probably too breezy to translate well into other languages. Perhaps "is also lost"? (Yes, I talk like this, too)

In the Security Considerations section, you might want to say something about (1) what watching the unencrypted PDM values might tell attackers that are doing pervasive monitoring (RFC 7258), and possibly about (2) what happens if PDM is used as a covert channel. I don't think either of these will be showstoppers at SECDIR review time, but I'd expect that demonstrating awareness of at least (1) will shorten the review comments cycle. Possibly a lot, judging by recent ballots on other drafts ...

---

From: Spencer Dawkins at IETF <[email-masked]>
Date: Tue, 13 Sep 2016 18:54:20 -0500

Nalini,

On Sep 13, 2016 18:04, <[email-masked]> wrote:
> We have added quite a bit to the Security Considerations.  We have
started implementation of PDM in the FreeBSD kernel, as I might have
mentioned before.   It has shed quite a bit of light on the potential
hazards which may come up as far as DOS attacks, etc.   That was helpful to
us in doing the Security Considerations.
> Many thanks to both you and Al Morton for your help and comments.

I'm happy. Al, is this version ready for IETF Last Call?

Thanks,

Spencer

> Nice work, and this would have been very valuable when I was implementing
performance monitors at Tektronix, so I imagine it's equally valuable now.
>
> I do have some comments that I'd like you let you consider before I
request IETF Last Call for this draft. Please let me know if you have any
questions, of course.
>
> Thanks,
>
> Spencer
>
> I saw the abstract following the table of contents mentioned in the
shepherd write-up, but https://tools.ietf.org/html/rfc7322#section-4.7 says
> It's probably a good thing to use the organization from RFC 7322, just to
sidestep reviewers who start out complaining about document structure nits
and then keep on typing. Not that I ever did that in six years as a Gen-ART
reviwer, of course :-) ...
> these are mathematical expressions, aren't they? If so, that would likely
be clearer if the right side terms had parentheses around the expression.
>
> (It's a bit odd that the first expression uses the abbreviation DELTATLR
and the second term is spelled out as "Delta Time Last Sent" - you might
think about which seems clearer, and do that with both expressions)
> you probably want to use a verb like "specify" (when the draft is
published as an RFC, it will no longer be a proposal). There are multiple
occurrences of "propose" in the document, so this comment applies in
multiple places.
> that's an interesting point in the broader sense, because (duh) putting
PDM in a TCP option doesn't help you with any other transport protocol
(SCTP, QUIC, what else are we doing these days? and, of course, they're all
running over UDP anyway). I wonder if that's worth pointing out earlier in
the document, perhaps in Section 1.4?
> is probably too breezy to translate well into other languages. Perhaps
"is also lost"? (Yes, I talk like this, too)
>
> In the Security Considerations section, you might want to say something
about (1) what watching the unencrypted PDM values might tell attackers
that are doing pervasive monitoring (RFC 7258), and possibly about (2) what
happens if PDM is used as a covert channel. I don't think either of these
will be showstoppers at SECDIR review time, but I'd expect that
demonstrating awareness of at least (1) will shorten the review comments
cycle. Possibly a lot, judging by recent ballots on other drafts ...

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Tue, 13 Sep 2016 22:07:50 -0400

I’ll check first thing tomorrow,
thanks!
Al

From: Spencer Dawkins at IETF [mailto:[email-masked]]
Sent: Tuesday, September 13, 2016 7:54 PM
To: Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; [email-masked]
Subject: Re: AD review of draft-ietf-ippm-6man-pdm-option-03

Nalini,

Thanks,

Spencer

> www.insidethestack.com<http://www.insidethestack.com>
> (831) 659-8360
>
>
>
> From: Spencer Dawkins at IETF <[email-masked]<mailto:[email-masked]>>
> To: [email-masked]<mailto:[email-masked]>
> Cc: [email-masked]<mailto:[email-masked]>

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Wed, 14 Sep 2016 08:47:30 -0400

Hi all,

I’m satisfied with this version, Last Call is next step.
I think all my comments have been addressed.

...
I’m glad to see the expanded Security Considerations.
One small clarification could be made in the *next* version,
at the end of section 8.1:

   We recommend that implementation of PDM SHOULD have a limit on the
   size of the control blocks used.

Since you’ve already said that the control block is quite small,
maybe this recommendation is on the number of control blocks?

   We recommend that implementation of PDM SHOULD have a limit on the
   number of the control blocks used.
  ^^^^^^

thanks authors!
Al

From: MORTON, ALFRED C (AL)
Sent: Tuesday, September 13, 2016 10:08 PM
To: Spencer Dawkins at IETF; Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; [email-masked]
Subject: RE: AD review of draft-ietf-ippm-6man-pdm-option-03

From: Spencer Dawkins at IETF [mailto:[email-masked]]
Sent: Tuesday, September 13, 2016 7:54 PM
To: Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: AD review of draft-ietf-ippm-6man-pdm-option-03

Nalini,

Thanks,

Spencer

---

From: <[email-masked]>
Date: Wed, 14 Sep 2016 13:19:39 +0000 (UTC)

Hi all,

  >I’m satisfied with this version, Last Call is next step.>I think all my comments have been addressed.  Great!
...>I’m glad to see the expanded Security Considerations.>One small clarification could be made in the *next* version,>at the end of section 8.1:    >   We recommend that implementation of PDM SHOULD have a limit on the   >size of the control blocks used.  >Since you’ve already said that the control block is quite small,>maybe this recommendation is on the number of control blocks?  >   We recommend that implementation of PDM SHOULD have a limit on the
 >  number of the control blocks used. > ^^^^^^
Yes.  This should more properly be the number of entries possible for the control block table.   That is, after 500 entries (or whatever the implementation chooses), then the oldest entries would be dropped (or however the implementation chooses to handle it)
> thanks authors!
Thank YOU, Al!
Nalini From: MORTON, ALFRED C (AL) 
Sent: Tuesday, September 13, 2016 10:08 PM
To: Spencer Dawkins at IETF; Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; [email-masked]
Subject: RE: AD review of draft-ietf-ippm-6man-pdm-option-03  I’ll check first thing tomorrow,thanks!Al  From: Spencer Dawkins at IETF [mailto:[email-masked]] 
Sent: Tuesday, September 13, 2016 7:54 PM
To: Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; [email-masked]
Subject: Re: AD review of draft-ietf-ippm-6man-pdm-option-03  Nalini, On Sep 13, 2016 18:04, <[email-masked]> wrote:
> Many thanks to both you and Al Morton for your help and comments.I'm happy. Al, is this version ready for IETF Last Call?Thanks, Spencer> - Nalini Elkins - on behalf of the PDM co-authors (Mike Ackermann and Rob Hamilton)
> Inside Products, Inc.
> www.insidethestack.com
> (831) 659-8360
>
>
>

   #yiv9805285447 #yiv9805285447 -- _filtered #yiv9805285447 {font-family:Calibri;panose-1:2 15 5 2 2 2 4 3 2 4;} _filtered #yiv9805285447 {font-family:Tahoma;panose-1:2 11 6 4 3 5 4 4 2 4;}#yiv9805285447 #yiv9805285447 p.yiv9805285447MsoNormal, #yiv9805285447 li.yiv9805285447MsoNormal, #yiv9805285447 div.yiv9805285447MsoNormal {margin:0in;margin-bottom:.0001pt;font-size:12.0pt;}#yiv9805285447 a:link, #yiv9805285447 span.yiv9805285447MsoHyperlink {color:blue;text-decoration:underline;}#yiv9805285447 a:visited, #yiv9805285447 span.yiv9805285447MsoHyperlinkFollowed {color:purple;text-decoration:underline;}#yiv9805285447 p {margin-right:0in;margin-left:0in;font-size:12.0pt;}#yiv9805285447 pre {margin:0in;margin-bottom:.0001pt;font-size:10.0pt;}#yiv9805285447 p.yiv9805285447MsoAcetate, #yiv9805285447 li.yiv9805285447MsoAcetate, #yiv9805285447 div.yiv9805285447MsoAcetate {margin:0in;margin-bottom:.0001pt;font-size:8.0pt;}#yiv9805285447 span.yiv9805285447EmailStyle18 {color:black;}#yiv9805285447 span.yiv9805285447BalloonTextChar {}#yiv9805285447 span.yiv9805285447EmailStyle21 {color:black;}#yiv9805285447 span.yiv9805285447HTMLPreformattedChar {}#yiv9805285447 .yiv9805285447MsoChpDefault {font-size:10.0pt;} _filtered #yiv9805285447 {margin:1.0in 1.0in 1.0in 1.0in;}#yiv9805285447 div.yiv9805285447WordSection1 {}#yiv9805285447

---

From: Spencer Dawkins at IETF <[email-masked]>
Date: Wed, 14 Sep 2016 09:34:02 -0500

Hi, Nalini,

On Wed, Sep 14, 2016 at 8:19 AM, <[email-masked]> wrote:

> Great!
> >One small clarification could be made in the **next** version,
> Yes.  This should more properly be the number of entries possible for the
> control block table.   That is, after 500 entries (or whatever the
> implementation chooses), then the oldest entries would be dropped (or
> however the implementation chooses to handle it)
>
> > thanks authors!
>
> Thank YOU, Al!
>

Please let me know if you'd like to make that change before Last Call.

(My experience as a Gen-ART reviewer is that once reviewers find one issue,
they come up with more, so not giving them one to start with that you
already know about is a good thing. But your mileage may differ, of course)

Spencer

>
> Nalini
>
> *From:* MORTON, ALFRED C (AL)
> *Sent:* Tuesday, September 13, 2016 10:08 PM
> *To:* Spencer Dawkins at IETF; Nalini Elkins
> *Cc:* MORTON, ALFRED C (AL); [email-masked]; draft-ietf-ippm-6man-pdm-
> [email-masked]
> *Subject:* RE: AD review of draft-ietf-ippm-6man-pdm-option-03
>
> *From:* Spencer Dawkins at IETF [mailto:[email-masked]
> <[email-masked]>]
> *Sent:* Tuesday, September 13, 2016 7:54 PM
> *To:* Nalini Elkins
> *Cc:* MORTON, ALFRED C (AL); [email-masked]; draft-ietf-ippm-6man-pdm-
> [email-masked]
> *Subject:* Re: AD review of draft-ietf-ippm-6man-pdm-option-03
>
> Nalini,
> > Nice work, and this would have been very valuable when I was
> implementing performance monitors at Tektronix, so I imagine it's equally
> valuable now.
> >
> > It's probably a good thing to use the organization from RFC 7322, just
> to sidestep reviewers who start out complaining about document structure
> nits and then keep on typing. Not that I ever did that in six years as a
> Gen-ART reviwer, of course :-) ...
> >
> > these are mathematical expressions, aren't they? If so, that would
> likely be clearer if the right side terms had parentheses around the
> expression.
> >

---

From: <[email-masked]>
Date: Wed, 14 Sep 2016 14:46:08 +0000 (UTC)

Spencer,

>(My experience as a Gen-ART reviewer is that once reviewers find one issue, they come up with more, so not giving them one to start with that you already know about is a good thing. But >your mileage may differ, of course)
Changes made.  New version at:
https://tools.ietf.org/html/draft-ietf-ippm-6man-pdm-option-05

Thank you for your guidance.
Nalini

Nalini From: MORTON, ALFRED C (AL) 
Sent: Tuesday, September 13, 2016 10:08 PM
To: Spencer Dawkins at IETF; Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; draft-ietf-ippm-6man-pdm- [email-masked]
Subject: RE: AD review of draft-ietf-ippm-6man-pdm- option-03  I’ll check first thing tomorrow,thanks!Al  From: Spencer Dawkins at IETF [mailto:spencerdawkins.ietf@ gmail.com] 
Sent: Tuesday, September 13, 2016 7:54 PM
To: Nalini Elkins
Cc: MORTON, ALFRED C (AL); [email-masked]; draft-ietf-ippm-6man-pdm- [email-masked]
Subject: Re: AD review of draft-ietf-ippm-6man-pdm- option-03  Nalini, On Sep 13, 2016 18:04, <nalini.elkins@insidethestack. com> wrote:
> https://tools.ietf.org/html/ draft-ietf-ippm-6man-pdm- option-04
>
> ______________________________ __
> From: Spencer Dawkins at IETF <[email-masked] >
> To: draft-ietf-ippm-6man-pdm- [email-masked]
> Cc: [email-masked]
> Subject: AD review of draft-ietf-ippm-6man-pdm- option-03
>
>
>
> Dear Authors,
>
> I saw the abstract following the table of contents mentioned in the shepherd write-up, but https://tools.ietf.org/html/ rfc7322#section-4.7 says
>

---

From: Spencer Dawkins at IETF <[email-masked]>
Date: Wed, 14 Sep 2016 10:54:53 -0500

Hi, Nalini,

On Wed, Sep 14, 2016 at 9:46 AM, <[email-masked]> wrote:

> >(My experience as a Gen-ART reviewer is that once reviewers find one
> issue, they come up with more, so not giving them one to start with that
> you already know about is a good thing. But >your mileage may differ, of
> course)
>

I checked the diff (and it was what I expected), and requested Last Call.

> Thank you for your guidance.

Oh, thank you :-)

Spencer

> [email-masked] <[email-masked]>
> *Subject:* RE: AD review of draft-ietf-ippm-6man-pdm- option-03
>
> *From:* Spencer Dawkins at IETF [mailto:spencerdawkins.ietf@ gmail.com
> [email-masked] <[email-masked]>
> *Subject:* Re: AD review of draft-ietf-ippm-6man-pdm- option-03
>
> Nalini,
> On Sep 13, 2016 18:04, <nalini.elkins@insidethestack. com
> <[email-masked]>> wrote:
> >
> > Spencer,
> >
> <https://tools.ietf.org/html/draft-ietf-ippm-6man-pdm-option-04>
> >
> <[email-masked]>
> > Cc: [email-masked]
> shepherd write-up, but https://tools.ietf.org/html/ rfc7322#section-4.7
> <https://tools.ietf.org/html/rfc7322#section-4.7> says
> >

---

From: <[email-masked]>
Date: Wed, 14 Sep 2016 15:58:49 +0000 (UTC)

Spencer,
Wonderful!
See you soon in Seoul. Thanks,
Nalini ElkinsInside Products, Inc.www.insidethestack.com(831) 659-8360

      From: Spencer Dawkins at IETF <[email-masked]>
 To: Nalini Elkins <[email-masked]> 
Cc: "MORTON, ALFRED C (AL)" <[email-masked]>; "[email-masked]" <[email-masked]>; "[email-masked]" <[email-masked]>
 Sent: Wednesday, September 14, 2016 8:54 AM
 Subject: Re: AD review of draft-ietf-ippm-6man-pdm-option-03
   
Hi, Nalini,

Spencer,

Changes made.  New version at:
https://tools.ietf.org/html/ draft-ietf-ippm-6man-pdm- option-05

Oh, thank you :-)
Spencer 

Nalini